

license = """

AMD OpenCL 2.2 SDK


End User License Agreement

 

PLEASE READ THIS LICENSE CAREFULLY BEFORE USING THE SOFTWARE.  BY
USING THE SOFTWARE, YOU ARE AGREEING TO BE BOUND BY THE TERMS OF THIS
LICENSE.

 

 

1. License. The software accompanying this License (hereinafter
"Software"), regardless of the media on which it is distributed,
are licensed to you by Advanced Micro Devices, Inc. ("AMD") for use
solely in conjunction with AMD hardware products purchased with the
Software ("AMD Hardware").  You own the medium on which the Software
is recorded, but AMD and AMD's Licensors (referred to collectively as
"AMD") retain title to the Software and related documentation.  You
may:

a) use the Software solely in conjunction with the AMD Hardware on a
single computer;

b) make one copy of the Software in machine-readable form for backup
purposes only.  You must reproduce on such copy AMD's copyright notice
and any other proprietary legends that were on the original copy of
the Software;

c) transfer all your license rights in the Software provided you must
also transfer a copy of this License, the backup copy of the Software,
the AMD Hardware and the related documentation and provided the other
party reads and agrees to accept the terms and conditions of this
License.  Upon such transfer your license is then terminated.

 

2.  Restrictions. The Software contains copyrighted and patented
material, trade secrets and other proprietary material.  In order to
protect them, and except as permitted by applicable legislation, you
may not:

a) decompile, reverse engineer, disassemble or otherwise reduce the
Software to a human-perceivable form;

b) modify, network, rent, lend, loan, distribute or create derivative
works based upon the Software in whole or in part; or

c) electronically transmit the Software from one computer to another
or over a network or otherwise transfer the Software except as
permitted by this License.

 

3.  Termination. This License is effective until terminated.  You may
terminate this License at any time by destroying the Software, related
documentation and all copies thereof.  This License will terminate
immediately without notice from AMD if you fail to comply with any
provision of this License.  Upon termination you must destroy the
Software, related documentation and all copies thereof.

 

4.  Government End Users. If you are acquiring the Software on behalf
of any unit or agency of the United States Government, the following
provisions apply.  The Government agrees the Software and
documentation were developed at private expense and are provided with
"RESTRICTED RIGHTS".  Use, duplication, or disclosure by the
Government is subject to restrictions as set forth in DFARS
227.7202-1(a) and 227.7202-3(a) (1995), DFARS 252.227-7013(c)(1)(ii)
(Oct 1988), FAR 12.212(a)(1995), FAR 52.227-19, (June 1987) or FAR
52.227-14(ALT III) (June 1987), as amended from time to time.  In the
event that this License, or any part thereof, is deemed inconsistent
with the minimum rights identified in the Restricted Rights
provisions, the minimum rights shall prevail.

 

5.  No Other License.  No rights or licenses are granted by AMD under
this License, expressly or by implication, with respect to any
proprietary information or patent, copyright, trade secret or other
intellectual property right owned or controlled by AMD, except as
expressly provided in this License.

 

6.  Additional Licenses. DISTRIBUTION OR USE OF THE SOFTWARE WITH AN
OPERATING SYSTEM MAY REQUIRE ADDITIONAL LICENSES FROM THE OPERATING
SYSTEM VENDOR.

 

7.  Disclaimer of Warranty on Software. You expressly acknowledge and
agree that use of the Software is at your sole risk.  The Software and
related documentation are provided "AS IS" and without warranty of any
kind and AMD EXPRESSLY DISCLAIMS ALL WARRANTIES, EXPRESS AND IMPLIED,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  AMD DOES NOT
WARRANT THAT THE FUNCTIONS CONTAINED IN THE SOFTWARE WILL MEET YOUR
REQUIREMENTS, OR THAT THE OPERATION OF THE SOFTWARE WILL BE
UNINTERRUPTED OR ERROR-FREE, OR THAT DEFECTS IN THE SOFTWARE WILL BE
CORRECTED.  THE ENTIRE RISK AS TO THE RESULTS AND PERFORMANCE OF THE
SOFTWARE IS ASSUMED BY YOU.  FURTHERMORE, AMD DOES NOT WARRANT OR MAKE
ANY REPRESENTATIONS REGARDING THE USE OR THE RESULTS OF THE USE OF THE
SOFTWARE OR RELATED DOCUMENTATION IN TERMS OF THEIR CORRECTNESS,
ACCURACY, RELIABILITY, CURRENTNESS, OR OTHERWISE. NO ORAL OR WRITTEN
INFORMATION OR ADVICE GIVEN BY AMD OR AMD'S AUTHORIZED REPRESENTATIVE
SHALL CREATE A WARRANTY OR IN ANY WAY INCREASE THE SCOPE OF THIS
WARRANTY.  SHOULD THE SOFTWARE PROVE DEFECTIVE, YOU (AND NOT AMD OR
AMD'S AUTHORIZED REPRESENTATIVE) ASSUME THE ENTIRE COST OF ALL
NECESSARY SERVICING, REPAIR OR CORRECTION.  THE SOFTWARE IS NOT
INTENDED FOR USE IN MEDICAL, LIFE SAVING OR LIFE SUSTAINING
APPLICATIONS.  SOME JURISDICTIONS DO NOT ALLOW THE EXCLUSION OF
IMPLIED WARRANTIES, SO THE ABOVE EXCLUSION MAY NOT APPLY TO YOU.

 

8.  Limitation of Liability. UNDER NO CIRCUMSTANCES INCLUDING
NEGLIGENCE, SHALL AMD, OR ITS DIRECTORS, OFFICERS, EMPLOYEES OR
AGENTS, BE LIABLE TO YOU FOR ANY INCIDENTAL, INDIRECT, SPECIAL OR
CONSEQUENTIAL DAMAGES (INCLUDING DAMAGES FOR LOSS OF BUSINESS PROFITS,
BUSINESS INTERRUPTION, LOSS OF BUSINESS INFORMATION, AND THE LIKE)
ARISING OUT OF THE USE, MISUSE OR INABILITY TO USE THE SOFTWARE OR
RELATED DOCUMENTATION, BREACH OR DEFAULT, INCLUDING THOSE ARISING FROM
INFRINGEMENT OR ALLEGED INFRINGEMENT OF ANY PATENT, TRADEMARK,
COPYRIGHT OR OTHER INTELLECTUAL PROPERTY RIGHT, BY AMD, EVEN IF AMD OR
AMD'S AUTHORIZED REPRESENTATIVE HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGES.  SOME JURISDICTIONS DO NOT ALLOW THE LIMITATION OR
EXCLUSION OF LIABILITY FOR INCIDENTAL OR CONSEQUENTIAL DAMAGES, SO THE
ABOVE LIMITATION OR EXCLUSION MAY NOT APPLY TO YOU.  AMD will not be
liable for 1)loss of, or damage to, your records or data or 2) any
damages claimed by you based on any third party claim.  In no event
shall AMD's total liability to you for all damages, losses, and causes
of action (whether in contract, tort (including negligence) or
otherwise) exceed the amount paid by you for the Software.

 

9.  Controlling Law and Severability. This Agreement will be governed
by and construed under the laws of the State of California without
reference to its conflicts of law principles. The rights and
obligations under this Agreement shall not be governed by the United
Nations Convention on Contracts or the International Sale of Goods,
the application of which is expressly excluded.  Each party hereto
submits to the jurisdiction of the state and federal courts of Santa
Clara County and the Northern District of California for the purpose
of all legal proceedings arising out of or relating to this Agreement
or the subject matter hereof.  Each party waives any objection which
it may have to contest such forum.

 

10.  Complete Agreement.  This License constitutes the entire
agreement between the parties with respect to the use of the Software
and the related documentation, and supersedes all prior or
contemporaneous understandings or agreements, written or oral,
regarding such subject matter.  No amendment to or modification of
this License will be binding unless in writing and signed by a duly
authorized representative of AMD.



"""

def get_arch():
    import platform
    return platform.architecture()


def check_arch(arch):

    supported_archs = (('64bit', 'ELF'), ('32bit', 'ELF'))

    if not arch in supported_archs:
        raise NotImplementedError, \
              "Unsupported platform '%s', Supported platforms: %s" %\
              (str(arch), str(supported_archs))


def download(arch=None, url_root=None,target_dir = './.opencl_pkgs'):
    from urllib import urlretrieve
    import os

    if arch==None:
        arch = get_arch()

    check_arch(arch)

    if url_root == None:
        url_root = 'http://download2-developer.amd.com/amd/Stream20GA/'

    pkg_map = {}
    pkg_map['64bit'] = 'ati-stream-sdk-v2.2-lnx64.tgz'
    pkg_map['32bit'] = 'ati-stream-sdk-v2.2-lnx32.tgz'

    sizes = {'ati-stream-sdk-v2.2-lnx64.tgz':73427109L,
             'ati-stream-sdk-v2.2-lnx32.tgz':47031307L,
             'icd-registration.tgz':213}


    # filenames
    icd_fn = 'icd-registration.tgz'
    pkg_fn = pkg_map[arch[0]]

    if not os.path.exists(target_dir):
        os.mkdir(target_dir)
    if not os.path.isdir(target_dir):
        raise RuntimeError, "Existing file '%s' conflicts with target dir" % target_dir

    file_map = {'icd':icd_fn,'sdk':pkg_fn}
    path_map = {}

    for key,fn in file_map.iteritems():
        target = os.path.join(target_dir,fn)
        path_map[key] = target
        if os.path.exists(target) and os.path.getsize(target)==sizes[fn]:
            print "File '%s' exists and is of correct size, skipping." % target
        else:
            #urlretrieve(url_root+fn, target)
            os.system("wget %s -O %s" % (url_root+fn, target))

    return path_map
