
from helpers import dl_amd_opencl as dlamd
from helpers import cpuinfo
import os, sys

prefix = '/opt'

# Check we're on 64bit or 32bit linux
arch = dlamd.get_arch()
dlamd.check_arch(arch)

d_cpuinfo = cpuinfo.cpuinfo()

if not 'sse2' in d_cpuinfo['flags']:
    print "Sorry, your CPU does not support SSE2, no OpenCL support for you!"
    sys.exit(1)

print "Fetching opencl packages from AMD website ..."
fmap = dlamd.download(arch)

cmd = "sudo tar -C %s -zxvf %s" % (prefix,fmap['sdk'])
os.system(cmd)

cmd = "sudo tar -C %s -zxvf %s" % ('/',fmap['icd'])
os.system(cmd)

# predict sdk root dir
sdk_dir = os.path.split(os.path.splitext(fmap['sdk'])[0])[1]

lib_dir_map = {'32bit':'x86','64bit':'x86_64'}

lib_dir = '/opt/%s/lib/%s' % (sdk_dir, lib_dir_map[arch[0]])
inc_dir = '/opt/%s/include' % (sdk_dir)

# build and install pyopencl

print "Getting pyopencl ..."
os.system('wget -O ./.opencl_pkgs/pyopencl-0.92.tar.gz http://pypi.python.org/packages/source/p/pyopencl/pyopencl-0.92.tar.gz')
# md5=0680f7272fe3ab5a3bcb0b6cfbd74994

# sudo easy_install -U distribute
os.system("sudo easy_install -U distribute")

cmd = """
python configure.py \
  --boost-inc-dir=/usr/include/boost \
  --boost-lib-dir=/usr/lib \
  --boost-python-libname=boost_python-mt-py26 \
  --cl-inc-dir=%(inc_dir)s \
  --cl-lib-dir=%(lib_dir)s \
  --cl-libname=OpenCL
""" % {'inc_dir':inc_dir,'lib_dir':lib_dir}
os.system("cd ./.opencl_pkgs && tar -zxvf pyopencl-0.92.tar.gz")
os.system("cd ./.opencl_pkgs/pyopencl-0.92 && %s" % cmd)
os.system("cd ./.opencl_pkgs/pyopencl-0.92 && make")
os.system("cd ./.opencl_pkgs/pyopencl-0.92 && sudo make install")

#  --boost-thread-libname=boost_thread-mt \#/opt/ati-stream-sdk-v2.2-lnx32/lib/x86/
#/opt/ati-stream-sdk-v2.2-lnx64/lib/x86_64 

# make
# sudo make install

opencl_ldconf = "\n%s\n" % lib_dir

print "Running ldconf..."

file('opencl.conf','w').writelines(opencl_ldconf.split('\n'))
os.system("sudo mv opencl.conf /etc/ld.so.conf.d")
os.system("sudo ldconfig")

